package com.dxhy.erp.enums;

import com.dxhy.erp.controller.InterfaceController;
import com.dxhy.erp.controller.SDNYMainProcessController;
import com.dxhy.erp.service.SNPushCheckRecordService;

import java.util.Map;

public enum RequestRecordEnum {

    SYNC_INVOICE_INFO("/syncInvoiceInfo", "syncInvoiceInfo", SDNYMainProcessController.class),

    SINGLE_INVOICE_CHECK("/singleInvoiceCheck", "singleInvoiceCheck", SDNYMainProcessController.class),

    RECEIVE_ERP_INVOICE_MESSAGE("/po", "receiveErpInvoiceMessage", InterfaceController.class),

    TRANSFER_OUT("/po", "transferOut", InterfaceController.class),

    INSERT_VOUNCHER_RECORD("/po", "insertVouncherRecord", InterfaceController.class),

    PUSH_CHECK_RESULT_TO_SAP("pushCheckResultToSAP", SNPushCheckRecordService.class, String.class),

    SING_CHECK_INVOICE("singleCheckInvoice",SNPushCheckRecordService.class, Map.class);


    private String portName;
    private String methodName;
    private Class<?> argClass;
    private Class<?> controllerName;


    RequestRecordEnum(String portName, String methodName, Class<?> controllerClass) {
        this.portName = portName;
        this.methodName = methodName;
        this.controllerName = controllerClass;
    }

    RequestRecordEnum(String methodName, Class<?> controllerClass, Class<?> argClass) {
        this.methodName = methodName;
        this.controllerName = controllerClass;
        this.argClass = argClass;
    }

    public void setPortName(String portName) {
        this.portName = portName;
    }

    public void setMethodName(String methodName) {
        this.methodName = methodName;
    }

    public void setControllerName(Class<?> controllerName) {
        this.controllerName = controllerName;
    }

    public String getPortName() {
        return portName;
    }

    public String getMethodName() {
        return methodName;
    }

    public Class<?> getControllerName() {
        return controllerName;
    }

    public Class<?> getArgClass() {
        return argClass;
    }

    public void setArgClass(Class<?> argClass) {
        this.argClass = argClass;
    }
}
